diff --git a/test/api/project.json b/test/api/project.json
index 00c7e332e..26ff679b2 100644
--- a/test/api/project.json
+++ b/test/api/project.json
@@ -10,9 +10,6 @@
             "flecs"
         ]
     },
-    "lang.c": {
-        "cflags": ["-fsanitize=undefined"]
-    },
     "test": {
         "testsuites": [{
             "id": "New",
@@ -424,6 +421,15 @@
                 "on_set_after_override_1_of_2_overridden",
                 "on_set_after_snapshot_restore"
             ]
+        }, {
+            "id": "Monitor",
+            "testcases": [
+                "1_comp",
+                "2_comps",
+                "1_comp_1_not",
+                "1_parent",
+                "1_comp_1_parent"
+            ]
         }, {
             "id": "SystemPeriodic",
             "testcases": [
diff --git a/test/api/src/Monitor.c b/test/api/src/Monitor.c
new file mode 100644
index 000000000..e24096f92
--- /dev/null
+++ b/test/api/src/Monitor.c
@@ -0,0 +1,215 @@
+#include <api.h>
+
+static
+void OnPosition(ecs_rows_t *rows) {
+    probe_system(rows);
+}
+
+void Monitor_1_comp() {
+    ecs_world_t *world = ecs_init();
+
+    ECS_COMPONENT(world, Position);
+    ECS_COMPONENT(world, Velocity);
+    ECS_SYSTEM(world, OnPosition, 0, Position, SYSTEM.EcsMonitor);
+
+    Probe ctx = { 0 };
+    ecs_set_context(world, &ctx);
+
+    ecs_entity_t e = ecs_new(world, Position);
+    test_int(ctx.invoked, 1);
+    test_int(ctx.count, 1);
+    test_int(ctx.system, OnPosition);
+    test_int(ctx.column_count, 2);
+    test_null(ctx.param);
+
+    test_int(ctx.e[0], e);
+    test_int(ctx.c[0][0], ecs_entity(Position));
+    test_int(ctx.s[0][0], 0);
+
+    ctx = (Probe){ 0 };
+
+    ecs_progress(world, 0);
+    test_int(ctx.invoked, 0);
+
+    ecs_add(world, e, Velocity);
+    test_int(ctx.invoked, 0);
+
+    ecs_fini(world);
+}
+
+void Monitor_2_comps() {
+    ecs_world_t *world = ecs_init();
+
+    ECS_COMPONENT(world, Position);
+    ECS_COMPONENT(world, Velocity);
+    ECS_SYSTEM(world, OnPosition, 0, Position, Velocity, SYSTEM.EcsMonitor);
+
+    Probe ctx = { 0 };
+    ecs_set_context(world, &ctx);
+
+    ecs_entity_t e = ecs_new(world, Position);
+    test_int(ctx.invoked, 0);
+
+    ecs_add(world, e, Velocity);
+    test_int(ctx.invoked, 1);
+    test_int(ctx.count, 1);
+    test_int(ctx.system, OnPosition);
+    test_int(ctx.column_count, 3);
+    test_null(ctx.param);
+
+    test_int(ctx.e[0], e);
+    test_int(ctx.c[0][0], ecs_entity(Position));
+    test_int(ctx.s[0][0], 0);
+    test_int(ctx.c[0][1], ecs_entity(Velocity));
+    test_int(ctx.s[0][1], 0);    
+
+    ctx = (Probe){ 0 };
+
+    ecs_remove(world, e, Position);
+    test_int(ctx.invoked, 0);
+
+    ecs_add(world, e, Position);
+    test_int(ctx.invoked, 1);    
+    test_int(ctx.count, 1);
+    test_int(ctx.system, OnPosition);
+    test_int(ctx.column_count, 3);
+    test_null(ctx.param);
+
+    test_int(ctx.e[0], e);
+    test_int(ctx.c[0][0], ecs_entity(Position));
+    test_int(ctx.s[0][0], 0);
+    test_int(ctx.c[0][1], ecs_entity(Velocity));
+    test_int(ctx.s[0][1], 0); 
+
+    ecs_fini(world);
+}
+
+void Monitor_1_comp_1_not() {
+    ecs_world_t *world = ecs_init();
+
+    ECS_COMPONENT(world, Position);
+    ECS_COMPONENT(world, Velocity);
+    ECS_SYSTEM(world, OnPosition, 0, Position, !Velocity, SYSTEM.EcsMonitor);
+
+    Probe ctx = { 0 };
+    ecs_set_context(world, &ctx);
+
+    ecs_entity_t e = ecs_new(world, Position);
+    test_int(ctx.invoked, 1);
+    test_int(ctx.count, 1);
+    test_int(ctx.system, OnPosition);
+    test_int(ctx.column_count, 3);
+    test_null(ctx.param);
+
+    test_int(ctx.e[0], e);
+    test_int(ctx.c[0][0], ecs_entity(Position));
+    test_int(ctx.s[0][0], 0);
+    test_int(ctx.c[0][1], ecs_entity(Velocity));
+    test_int(ctx.s[0][1], 0);    
+
+    ctx = (Probe){ 0 };
+
+    ecs_add(world, e, Velocity);
+    test_int(ctx.invoked, 0);
+
+    ecs_remove(world, e, Velocity);
+    test_int(ctx.invoked, 1);    
+    test_int(ctx.count, 1);
+    test_int(ctx.system, OnPosition);
+    test_int(ctx.column_count, 3);
+    test_null(ctx.param);
+
+    test_int(ctx.e[0], e);
+    test_int(ctx.c[0][0], ecs_entity(Position));
+    test_int(ctx.s[0][0], 0);
+    test_int(ctx.c[0][1], ecs_entity(Velocity));
+    test_int(ctx.s[0][1], 0); 
+
+    ecs_fini(world);
+}
+
+void Monitor_1_parent() {
+    ecs_world_t *world = ecs_init();
+
+    ECS_COMPONENT(world, Position);
+    ECS_COMPONENT(world, Velocity);
+    ECS_SYSTEM(world, OnPosition, 0, PARENT.Position, SYSTEM.EcsMonitor);
+
+    Probe ctx = { 0 };
+    ecs_set_context(world, &ctx);
+
+    ecs_entity_t parent = ecs_new(world, Position);
+    test_int(ctx.invoked, 0);
+
+    ecs_entity_t e = ecs_new(world, 0);
+    test_int(ctx.invoked, 0);
+
+    ecs_add_entity(world, e, ECS_CHILDOF | parent);
+    test_int(ctx.invoked, 1);
+    test_int(ctx.count, 1);
+    test_int(ctx.system, OnPosition);
+    test_int(ctx.column_count, 2);
+    test_null(ctx.param);
+
+    test_int(ctx.e[0], e);
+    test_int(ctx.c[0][0], ecs_entity(Position));
+    test_int(ctx.s[0][0], parent); 
+
+    ecs_fini(world);
+}
+
+void Monitor_1_comp_1_parent() {
+    ecs_world_t *world = ecs_init();
+
+    ECS_COMPONENT(world, Position);
+    ECS_COMPONENT(world, Velocity);
+    ECS_SYSTEM(world, OnPosition, 0, Position, PARENT.Position, SYSTEM.EcsMonitor);
+
+    Probe ctx = { 0 };
+    ecs_set_context(world, &ctx);
+
+    ecs_entity_t parent = ecs_new(world, Position);
+    test_int(ctx.invoked, 0);
+
+    ecs_entity_t e = ecs_new(world, Position);
+    test_int(ctx.invoked, 0);
+
+    ecs_add_entity(world, e, ECS_CHILDOF | parent);
+    test_int(ctx.invoked, 1);
+    test_int(ctx.count, 1);
+    test_int(ctx.system, OnPosition);
+    test_int(ctx.column_count, 3);
+    test_null(ctx.param);
+
+    test_int(ctx.e[0], e);
+    test_int(ctx.c[0][0], ecs_entity(Position));
+    test_int(ctx.s[0][0], 0);
+    test_int(ctx.c[0][1], ecs_entity(Position));
+    test_int(ctx.s[0][1], parent);    
+
+    ctx = (Probe){ 0 };
+
+    ecs_add(world, e, Velocity);
+    test_int(ctx.invoked, 0);
+
+    ecs_remove(world, e, Velocity);
+    test_int(ctx.invoked, 0);
+
+    ecs_remove(world, e, Position);
+    test_int(ctx.invoked, 0);
+
+    ecs_add(world, e, Position);
+    test_int(ctx.invoked, 1);    
+    test_int(ctx.count, 1);
+    test_int(ctx.system, OnPosition);
+    test_int(ctx.column_count, 3);
+    test_null(ctx.param);
+
+    test_int(ctx.e[0], e);
+    test_int(ctx.c[0][0], ecs_entity(Position));
+    test_int(ctx.s[0][0], 0);
+    test_int(ctx.c[0][1], ecs_entity(Position));
+    test_int(ctx.s[0][1], parent);
+
+    ecs_fini(world);
+}
diff --git a/test/api/src/main.c b/test/api/src/main.c
index 5a7b97c3a..200044d3e 100644
--- a/test/api/src/main.c
+++ b/test/api/src/main.c
@@ -372,6 +372,13 @@ void TriggerOnSet_on_set_after_override_w_new_w_count(void);
 void TriggerOnSet_on_set_after_override_1_of_2_overridden(void);
 void TriggerOnSet_on_set_after_snapshot_restore(void);
 
+// Testsuite 'Monitor'
+void Monitor_1_comp(void);
+void Monitor_2_comps(void);
+void Monitor_1_comp_1_not(void);
+void Monitor_1_parent(void);
+void Monitor_1_comp_1_parent(void);
+
 // Testsuite 'SystemPeriodic'
 void SystemPeriodic_1_type_1_component(void);
 void SystemPeriodic_1_type_3_component(void);
@@ -2306,6 +2313,32 @@ static bake_test_suite suites[] = {
             }
         }
     },
+    {
+        .id = "Monitor",
+        .testcase_count = 5,
+        .testcases = (bake_test_case[]){
+            {
+                .id = "1_comp",
+                .function = Monitor_1_comp
+            },
+            {
+                .id = "2_comps",
+                .function = Monitor_2_comps
+            },
+            {
+                .id = "1_comp_1_not",
+                .function = Monitor_1_comp_1_not
+            },
+            {
+                .id = "1_parent",
+                .function = Monitor_1_parent
+            },
+            {
+                .id = "1_comp_1_parent",
+                .function = Monitor_1_comp_1_parent
+            }
+        }
+    },
     {
         .id = "SystemPeriodic",
         .testcase_count = 49,
@@ -4351,5 +4384,5 @@ static bake_test_suite suites[] = {
 
 int main(int argc, char *argv[]) {
     ut_init(argv[0]);
-    return bake_test_run("api", argc, argv, suites, 47);
+    return bake_test_run("api", argc, argv, suites, 48);
 }
